#!/bin/sh

key_file=""
tilde_username=""
tilde_name=""

startx_command="startlxqt"

. ./util.sh
. ./connection.sh
. ./user.sh

choice=""

clear
echo "=== Welcome to Tildelinux! ==="
configure_network
clear

echo "What tilde would you like to connect to? (use the domain name as you would for ssh)"
read tilde_name

echo "What is your username for $tilde_name?"
read tilde_username

echo "Now you will need to provide tildelinux with your ssh private key"
echo "By whatever means, place your private key in the /tilde/key directory"
echo "Here is a shell, once the key is in the proper location, simply type \"exit\" to close the shell and continue"
bash

echo "Looking for key file..."
key_file="$(find_key_file '/tilde/key')"
while [ -z "$key_file" ]
do
	echo "Could not find a valid key file in /tilde/key"
	echo "Use this shell to try and fix any problems, then check again by exiting this shell"
	echo "Use \`exit 1\` to abort the install"
	bash || fail
	key_file="$(find_key_file '/tilde/key')"
done
echo "Key file located at $key_file, testing connection..."
connection_test "$key_file" "$tilde_username" "$tilde_name"

echo "Configuring user..."
configure_user "$key_file" "$tilde_username" "$tilde_name" "$startx_command"
echo "User configured!"

echo "All done! Enjoy using Tildelinux!"
rm ./setup_incomplete
systemctl restart 'getty@tty1.service'
